Index: messaging/src/main/org/jboss/mq/server/jmx/DestinationMBeanSupport.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/jmx/DestinationMBeanSupport.java,v
retrieving revision 1.10.4.5
diff -b -B -U8 -r1.10.4.5 DestinationMBeanSupport.java
--- messaging/src/main/org/jboss/mq/server/jmx/DestinationMBeanSupport.java	1 Aug 2005 16:42:17 -0000	1.10.4.5
+++ messaging/src/main/org/jboss/mq/server/jmx/DestinationMBeanSupport.java	26 Aug 2005 23:18:45 -0000
@@ -41,16 +41,18 @@
    String destinationName;
    String jndiName;
    boolean jndiBound;
    ObjectName jbossMQService;
    //String securityConf;
    Element securityConf;
    /** The basic parameters */
    BasicQueueParameters parameters = new BasicQueueParameters();
+   /** Destination JNDI name */
+   ObjectName expiryDestination;
 
    /**
     * A optional security manager. Must be set to use security conf.
     */
    ObjectName securityManager;
 
    /**
     * Get the value of JBossMQService.
@@ -100,27 +102,43 @@
    
    public void createService() throws Exception
    {
       // Copy default values from the server when null or zero
       if (parameters.receiversImpl == null)
          parameters.receiversImpl = (Class) server.getAttribute(jbossMQService, "ReceiversImpl");
       if (parameters.recoveryRetries == 0)
          parameters.recoveryRetries = ((Integer) server.getAttribute(jbossMQService, "RecoveryRetries")).intValue();
+      if (expiryDestination == null)
+         expiryDestination = (ObjectName) server.getAttribute(jbossMQService, "ExpiryDestination");
    }
    
    public void startService() throws Exception
    {
 
       if (securityManager != null)
       {
          // Set securityConf at manager
          getServer().invoke(securityManager, "addDestination", new Object[]{spyDest.getName(), securityConf}, new String[]{"java.lang.String", "org.w3c.dom.Element"});
       }
 
+      if (expiryDestination != null)
+      {
+         String jndi = (String)getServer().getAttribute(expiryDestination, "JNDIName");
+         InitialContext ctx = new InitialContext();
+         try
+         {
+            parameters.expiryDestination = (SpyDestination)ctx.lookup(jndi);
+         }
+         finally
+         {
+            ctx.close();
+         }
+      }
+
    }
 
    public void stopService() throws Exception
    {
       // unbind from JNDI
       if (jndiBound)
       {
          InitialContext ctx = new InitialContext();
@@ -501,9 +519,20 @@
    {
       return parameters.recoveryRetries;
    }
 
    public void setRecoveryRetries(int retries)
    {
       parameters.recoveryRetries = retries;
    }
+
+   public ObjectName getExpiryDestination() 
+   {
+      return expiryDestination;
+   }
+
+   public void setExpiryDestination(ObjectName expiryDestination)
+   {
+      this.expiryDestination = expiryDestination;
+   }
+
 }
Index: messaging/src/main/org/jboss/mq/server/jmx/DestinationManager.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/jmx/DestinationManager.java,v
retrieving revision 1.13.4.3
diff -b -B -U8 -r1.13.4.3 DestinationManager.java
--- messaging/src/main/org/jboss/mq/server/jmx/DestinationManager.java	12 Jul 2005 18:04:36 -0000	1.13.4.3
+++ messaging/src/main/org/jboss/mq/server/jmx/DestinationManager.java	26 Aug 2005 23:18:45 -0000
@@ -20,16 +20,18 @@
 import org.jboss.mq.pm.PersistenceManager;
 import org.jboss.mq.server.BasicQueueParameters;
 import org.jboss.mq.server.JMSDestinationManager;
 import org.jboss.mq.server.JMSServerInterceptor;
 import org.jboss.mq.server.MessageCache;
 import org.jboss.mq.server.MessageCounter;
 import org.jboss.mq.server.Receivers;
 import org.jboss.mq.sm.StateManager;
+import org.jboss.util.threadpool.ThreadPool;
+import org.jboss.util.threadpool.BasicThreadPool;
 import org.jboss.mx.util.MBeanProxyExt;
 import org.jboss.system.ServiceControllerMBean;
 
 /**
  * JMX MBean implementation for JBossMQ.
  *
  * @jmx:mbean extends="org.jboss.mq.server.jmx.InterceptorMBean"
  * @author     Vincent Sheffer (vsheffer@telkel.com)
@@ -52,16 +54,20 @@
    /** The JMX ObjectName of the configured persistence manager */
    private ObjectName persistenceManager;
    /** The JMX ObjectName of the configured state manager */
    private ObjectName stateManager;
    /** The JMX ObjectName of the message cache */
    private ObjectName messageCache;
    /** The temporary topic/queue parameters */
    private BasicQueueParameters tempParameters = new BasicQueueParameters();
+   /** Default thread pool */
+   private ObjectName threadPool;
+   /** Default expiry destination */
+   private ObjectName expiryDestination;
 
    /**
     * @jmx:managed-attribute
     * @return the count of active clients
     */
    public int getClientCount()
    {
       if (jmsServer == null)
@@ -214,16 +220,36 @@
       return tempParameters.recoveryRetries;
    }
 
    public void setRecoveryRetries(int retries)
    {
       tempParameters.recoveryRetries = retries;
    }
    
+   public ObjectName getThreadPool()
+   {
+      return this.threadPool;
+   }
+
+   public void setThreadPool(ObjectName threadPool)
+   {
+      this.threadPool = threadPool;
+   }
+   
+   public ObjectName getExpiryDestination() 
+   {
+      return expiryDestination;
+   }
+
+   public void setExpiryDestination(ObjectName expiryDestination)
+   {
+      this.expiryDestination = expiryDestination;
+   }
+
    /**
     * @jmx:managed-operation
     */
    public void createQueue(String name) throws Exception
    {
       createDestination("org.jboss.mq.server.jmx.Queue", getQueueObjectName(name), null);
    }
 
@@ -354,23 +380,41 @@
       PersistenceManager pm = (PersistenceManager) server.getAttribute(persistenceManager, "Instance");
       jmsServer.setPersistenceManager(pm);
 
       StateManager sm = (StateManager) server.getAttribute(stateManager, "Instance");
       jmsServer.setStateManager(sm);
 
       // We were either told the message cache or we get it from the
       // persistence manager
-      MessageCache mc = null;
+      MessageCache mc;
       if (messageCache != null)
          mc = (MessageCache) server.getAttribute(messageCache, "Instance");
       else
          mc = pm.getMessageCacheInstance();
       jmsServer.setMessageCache(mc);
 
+      ThreadPool tp;
+      ThreadGroup tg;
+      if (threadPool == null)
+      {
+         tg = new ThreadGroup("JBossMQ Server Threads");
+         tp = new BasicThreadPool("JMSThread", tg);
+      }
+      else
+      {
+         tp = (ThreadPool) server.getAttribute(threadPool, "Instance");
+         if (tp instanceof BasicThreadPool)
+           tg = ((BasicThreadPool)tp).getThreadGroup();
+         else
+           tg = new ThreadGroup("JBossMQ Server Threads");
+      }
+      jmsServer.setThreadPool(tp);
+      jmsServer.setThreadGroup(tg);
+
       jmsServer.startServer();
 
       super.startService();
    }
 
    protected void stopService()
    {
       jmsServer.stopServer();
Index: messaging/src/main/org/jboss/mq/server/jmx/DestinationManagerMBean.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/server/jmx/DestinationManagerMBean.java,v
retrieving revision 1.3.6.3
diff -b -B -U8 -r1.3.6.3 DestinationManagerMBean.java
--- messaging/src/main/org/jboss/mq/server/jmx/DestinationManagerMBean.java	12 Jul 2005 17:12:02 -0000	1.3.6.3
+++ messaging/src/main/org/jboss/mq/server/jmx/DestinationManagerMBean.java	26 Aug 2005 23:18:45 -0000
@@ -1,16 +1,18 @@
 /*
  * JBoss, the OpenSource J2EE webOS
  *
  * Distributable under LGPL license.
  * See terms of license at gnu.org.
  */
 package org.jboss.mq.server.jmx;
 
+import javax.management.ObjectName;
+
 /**
  * MBean interface.
  */
 public interface DestinationManagerMBean extends org.jboss.mq.server.jmx.InterceptorMBean
 {
 
    int getClientCount();
 
@@ -87,16 +89,36 @@
     */
    public int getRecoveryRetries();
 
    /**
     * Sets the class implementating the receivers
     */
    public void setRecoveryRetries(int retries);
 
+   /**
+    * Returns ThreadPool.
+    */
+   public ObjectName getThreadPool();
+
+   /**
+    * Sets ThreadPool.
+    */
+   public void setThreadPool(ObjectName threadPool);
+
+   /**
+    * Returns the expiry destination.
+    */
+   public ObjectName getExpiryDestination();
+
+   /**
+    * Sets the expiry destination.
+    */
+   public void setExpiryDestination(ObjectName destination);
+
    void createQueue(java.lang.String name) throws java.lang.Exception;
 
    void createTopic(java.lang.String name) throws java.lang.Exception;
 
    void createQueue(java.lang.String name, java.lang.String jndiLocation) throws java.lang.Exception;
 
    void createTopic(java.lang.String name, java.lang.String jndiLocation) throws java.lang.Exception;
 
Index: messaging/src/main/org/jboss/mq/threadpool/ThreadPool.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/threadpool/ThreadPool.java,v
retrieving revision 1.1
diff -b -B -U8 -r1.1 ThreadPool.java
--- messaging/src/main/org/jboss/mq/threadpool/ThreadPool.java	5 Oct 2001 19:34:14 -0000	1.1
+++ messaging/src/main/org/jboss/mq/threadpool/ThreadPool.java	26 Aug 2005 23:18:45 -0000
@@ -17,223 +17,9 @@
  *  This is an implementation of a simple thread pool with
  *  an embedded work queue.
  *
  * @author    Ole Husgaard (osh@sparre.dk)
  * @version   $Revision: 1.1 $
  */
 public class ThreadPool
 {
-   /**
-    *  The name of this thread pool
-    */
-   private String name;
-
-   /**
-    *  Flags that worker threads should be created as daemon threads.
-    */
-   private boolean daemon;
-
-   /**
-    *  The ThreadGroup of threads in this pool.
-    */
-   private ThreadGroup threadGroup;
-
-   /**
-    *  The worker threads.
-    */
-   private ArrayList workers;
-
-   /**
-    *  Maximum number of worker threads.
-    */
-   private int maxWorkers;
-
-   /**
-    *  Count of idle worker threads.
-    *  Synchronized on the [@link #workers} field.
-    */
-   private int idleWorkers;
-
-   /**
-    *  Flags that we are shutting down the pool.
-    *  Synchronized on the [@link #workers} field.
-    */
-   private volatile boolean stopping;
-
-   /**
-    *  The work queue.
-    */
-   private LinkedList queue;
-
-
-   /**
-    *  Create a new thread pool instance.
-    *
-    *  @param Name The name of this thread pool. This is used for naming its
-    *         worker threads.
-    *  @param threadGroup The <code>ThreadGroup</code> that worker threads
-    *         in this pool should belong to.
-    *  @param maxWorkers The maximum number of worker threads in this pool.
-    *  @param daemon If <code>true</code>, worker threads will be created as
-    *         daemon threads.
-    */
-   public ThreadPool(String name, ThreadGroup threadGroup, int maxWorkers,
-                     boolean daemon)
-   {
-      if (name == null || threadGroup == null || maxWorkers <= 0)
-         throw new IllegalArgumentException();
-
-      this.name = name;
-      this.daemon = daemon;
-      this.threadGroup = threadGroup;
-      workers = new ArrayList();
-      this.maxWorkers = maxWorkers;
-      idleWorkers = 0;
-      stopping = false;
-      queue = new LinkedList();
-   }
-
-   /**
-    *  Shutdown this thread pool.
-    *  This will not return until all enqueued work has been cancelled,
-    *  and all worker threads have done any work they started and have
-    *  died.
-    */
-    public void shutdown()
-    {
-       stopping = true;
-
-       synchronized (queue) {
-          // Remove all queued work
-          queue.clear();
-          // Notify all waiting threads
-          queue.notifyAll();
-       }
-
-       // wait for all worker threads to die.
-       synchronized (workers) {
-          while (workers.size() > 0) {
-             try {
-                // wait for some worker threads to die.
-                workers.wait();
-             } catch (InterruptedException ex) {
-                // ignore
-             }
-          }
-       }
-    }
-
-
-   /**
-    *  Enqueue a piece of work for this thread to handle.
-    *  As soon as a thread becomes available, it will call
-    *  {@link Work#doWork} of the argument.
-    *  If the pool is shutting down, this method will not enqueue the
-    *  work, but instead simply return.
-    *
-    *  @param work The piece of work to be enqueued.
-    */
-   public void enqueueWork(Work work)
-   {
-//System.err.println("ThreadPool("+name+"): enqueueWork() entered.");
-      // We may want to start a worker thread
-      synchronized (workers) {
-//System.err.println("ThreadPool("+name+"): enqueueWork(): idleWorkers="+idleWorkers+" stopping="+stopping+".");
-//System.err.println("ThreadPool("+name+"): enqueueWork(): workers.size()="+workers.size()+" maxWorkers="+maxWorkers+".");
-         if (idleWorkers == 0 && !stopping && workers.size() < maxWorkers)
-{
-            new WorkerThread(name + "-" + (workers.size() + 1)).start();
-//System.err.println("ThreadPool("+name+"): started new WorkerThread.");
-}
-      }
-
-      synchronized (queue) {
-         if (stopping)
-            return; // we are shutting down, cannot take new work.
-
-         queue.addLast(work);
-//System.err.println("ThreadPool("+name+"): enqueueWork(): enqueued work..");
-         queue.notify();
-      }
-   }
-
-   /**
-    *  Cancel a piece of enqueued work.
-    *
-    *  @param work The piece of work to be cancel.
-    */
-   public void cancelWork(Work work)
-   {
-      synchronized (queue) {
-         // It may be enqueued several times.
-         while (queue.remove(work))
-            ;
-      }
-   }
-
-
-   /**
-    *  The threads that do the actual work.
-    */
-   private class WorkerThread
-      extends Thread
-   {
-      /**
-       *  Create a new WorkerThread.
-       *  This must be called when holding the workers monitor.
-       */
-      WorkerThread(String name)
-      {
-         super(threadGroup, name);
-         setDaemon(daemon);
-         workers.add(this);
-//System.err.println("ThreadPool("+name+"): " + getName() + " created.");
-      }
-
-      /**
-       *  Wait for work do to.
-       *  This must be called when holding the queue monitor.
-       *  This will temporarily increment the count of idle workers
-       *  while waiting.
-       */
-      private void idle()
-      {
-         try {
-            synchronized (workers) {
-              ++idleWorkers;
-            }
-            //System.err.println("ThreadPool("+name+"): " + getName() + " starting to wait.");
-            queue.wait();
-         } catch (InterruptedException ex) {
-            // ignore
-         } finally {
-            //System.err.println("ThreadPool("+name+"): " + getName() + " done waiting.");
-            synchronized (workers) {
-              --idleWorkers;
-            }
-         }
-      }
-
-      public void run()
-      {
-//System.err.println("ThreadPool("+name+"): " + getName() + " started to run.");
-         while (!stopping) {
-            Work work = null;
-
-            synchronized (queue) {
-               if (queue.size() == 0)
-                  idle();
-               if (!stopping && queue.size() > 0)
-                  work = (Work)queue.removeFirst();
-            }
-
-            if (work != null)
-               work.doWork();
-         }
-         synchronized (workers) {
-            workers.remove(this);
-            // Notify the shutdown thread.
-            workers.notify();
-         }
-      }
-   }
 }
Index: messaging/src/main/org/jboss/mq/threadpool/Work.java
===================================================================
RCS file: /cvsroot/jboss/jbossmq/src/main/org/jboss/mq/threadpool/Work.java,v
retrieving revision 1.1
diff -b -B -U8 -r1.1 Work.java
--- messaging/src/main/org/jboss/mq/threadpool/Work.java	5 Oct 2001 19:34:14 -0000	1.1
+++ messaging/src/main/org/jboss/mq/threadpool/Work.java	26 Aug 2005 23:18:45 -0000
@@ -13,13 +13,9 @@
  *  interface to have one of the threads in the thread pool call
  *  back the method declared here.
  *
  * @author    Ole Husgaard (osh@sparre.dk)
  * @version   $Revision: 1.1 $
  */
 public interface Work
 {
-   /**
-    *  Callback to do the actual work.
-    */
-   public void doWork();
 }
